
#include "NativeFile.h"
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/fcntl.h>
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>

/*----------------------------------------------------------------*/
/* INIT                                                           */
/*----------------------------------------------------------------*/
JNIEXPORT void JNICALL Java_nativefile_NativeFile_Init
  (JNIEnv * env , jclass cl)
{
}



/*----------------------------------------------------------------*/
/* Open                                                           */
/*----------------------------------------------------------------*/

JNIEXPORT jlong JNICALL Java_nativefile_NativeFile_CreateFile
  (JNIEnv * env, jclass cl, jstring jfilename, jint jmode)
{
    const char *filename;
	short unifilename[100];
	int hand;

	filename = (*env)->GetStringUTFChars(env,jfilename,0);

//	ascii_to_uni(filename, unifilename);

	if(jmode == nativefile_NativeFile_MODE_READ)
	  hand = open( filename, O_RDONLY);

	if(jmode == nativefile_NativeFile_MODE_WRITE)
	  hand = open( filename, O_CREAT | O_WRONLY | O_TRUNC | O_SYNC, 0777 );


	if(jmode == nativefile_NativeFile_MODE_WRITE_EXISTING)
	  hand = open( filename, O_RDWR | O_SYNC, 0777 );

	(*env)->ReleaseStringUTFChars(env, jfilename, filename );

    return (jlong)hand;
}

/*----------------------------------------------------------------*/
/* Write                                                          */
/*----------------------------------------------------------------*/

JNIEXPORT jint JNICALL Java_nativefile_NativeFile_WriteFile
  (JNIEnv * env, jclass cl,jlong jhandle, jbyteArray jbuffer, jint size)
{
	 long erg;
        signed char *buffer;
	int rest;
	int pos;
	int ende = 0;


	buffer = (*env)->GetByteArrayElements(env,jbuffer,0);  // letzter parameter eigentlich pointer auf boolean ob copy


	rest = size;
	pos = 0;


//		return write(hand,&buffer[pos],rest);


	while(!ende)
	{
		erg = write(jhandle,&buffer[pos],rest);

		if(erg >= 0)
		{
		   pos += erg;
		   rest -= erg;
		   if(rest ==0 )
			  ende = 1;
		}
		else
		{
		   ende = 1;
		}
	}

	(*env)->ReleaseByteArrayElements(env, jbuffer, buffer,0 );

	return erg;
}


/*----------------------------------------------------------------*/
/* Read                                                           */
/*----------------------------------------------------------------*/

JNIEXPORT jint JNICALL Java_nativefile_NativeFile_ReadFile
  (JNIEnv * env, jclass cl, jlong jhandle, jbyteArray jbuffer, jint size)
{
	int erg=0;
    char buffer[1050];

    memset(buffer,0,1024);
	erg = read(jhandle,buffer,size);

	if(erg >= 0)
	{
			(*env)->SetByteArrayRegion(env, jbuffer, 0, erg, (jbyte *) buffer );

			return erg;
	}
	else
	{
			// ist wichtig hier, sonst frisst es Speicher auch wenn nix empfangen wird!
//		(*env)->ReleaseByteArrayElements(env, jbuffer, buffer, 0 );
		return -1;
	}
	return -2;  // wrong handle

}

/*----------------------------------------------------------------*/
/* Close                                                          */
/*----------------------------------------------------------------*/

JNIEXPORT void JNICALL Java_nativefile_NativeFile_CloseFile
  (JNIEnv * env, jclass cl, jlong jhandle)
{
	close(jhandle);
}

/*----------------------------------------------------------------*/
/* Truncate                                                       */
/*----------------------------------------------------------------*/

JNIEXPORT void JNICALL Java_nativefile_NativeFile_TruncateFile
  (JNIEnv * env, jclass cl, jstring jfilename , jint size  )
{
	const char *filename;

	filename = (*env)->GetStringUTFChars(env,jfilename,0);

	truncate(filename,size);

}



JNIEXPORT jint JNICALL Java_nativefile_NativeFile_GetLastError
  (JNIEnv * env, jclass cl)
{
	return 0;
//	return errno();
}


JNIEXPORT void JNICALL Java_nativefile_NativeFile_SetLastError
  (JNIEnv * env, jclass cl, jint jerror)
{
	truncate("/Volumes/VBOOT/boot",jerror);

}

/*----------------------------------------------------------------*/
/* Fragt ob Windows Ports zu benutzen sind                        */
/*----------------------------------------------------------------*/
JNIEXPORT jboolean JNICALL Java_nativefile_NativeFile_isWindows
  (JNIEnv * env , jclass cl)
{
	return 0;
}
