
#include "NativeFile.h"
#include <stdio.h>
#include <windows.h>
#include <winerror.h>
#include <string.h>


/*
void uni_to_ascii( const short * unistring , char *asciistring)
{
	int i=0;
	while(unistring[i])
	{
		asciistring[i] = (char)unistring[i];
		i++;
	}
    asciistring[i] = 0;
}

void ascii_to_uni( const char * asciistring , short *unistring)
{
	int i=0;
	while(asciistring[i])
	{
		unistring[i] = asciistring[i];
		i++;
	}
    unistring[i] = 0;
}
*/

/*----------------------------------------------------------------*/
/* INIT                                                           */
/*----------------------------------------------------------------*/
JNIEXPORT void JNICALL Java_nativefile_NativeFile_Init
  (JNIEnv * env , jclass cl)
{


}


/*----------------------------------------------------------------*/
/* Open                                                           */
/*----------------------------------------------------------------*/

JNIEXPORT jlong JNICALL Java_nativefile_NativeFile_CreateFile
  (JNIEnv * env, jclass cl, jstring jfilename, jint jmode)
{
	HANDLE hand;
    const char *filename;
//	short unifilename[100];
    int erg;
	DWORD mode=0;

	filename = (*env)->GetStringUTFChars(env,jfilename,0);


//    ascii_to_uni(filename, unifilename);

	if(jmode == nativefile_NativeFile_MODE_READ)
		hand = CreateFile(filename,     GENERIC_READ  ,    FILE_SHARE_READ , NULL, OPEN_EXISTING , FILE_ATTRIBUTE_NORMAL , NULL );

	if(jmode == nativefile_NativeFile_MODE_WRITE)
		hand = CreateFile(filename,     GENERIC_WRITE  ,    0 , 0, CREATE_ALWAYS , FILE_ATTRIBUTE_NORMAL , 0 );

	if(jmode == nativefile_NativeFile_MODE_WRITE_EXISTING)
		hand = CreateFile(filename,     GENERIC_WRITE  ,    0 , 0, CREATE_ALWAYS , FILE_ATTRIBUTE_NORMAL , 0 );

	(*env)->ReleaseStringUTFChars(env, jfilename, filename );

    return (jlong)hand;
}

/*----------------------------------------------------------------*/
/* Write                                                          */
/*----------------------------------------------------------------*/

JNIEXPORT jint JNICALL Java_nativefile_NativeFile_WriteFile
  (JNIEnv * env, jclass cl,jlong jhandle, jbyteArray jbuffer, jint size)
{
	HANDLE hand;
	unsigned long ergebnis=0;
	unsigned long erg=0;
    char *buffer;



		buffer = (*env)->GetByteArrayElements(env,jbuffer,0);  // letzter parameter eigentlich pointer auf boolean ob copy

		hand = (HANDLE)jhandle;


		if (WriteFile(hand, (LPCVOID)buffer, size, &ergebnis, 0))
			erg = ergebnis;  // anzahl geschriebenes ausgeben
		else
			erg = -1;

//		if (ergebnis != size)
//			erg = -2;


		(*env)->ReleaseByteArrayElements(env, jbuffer, buffer, 0 );

		return erg;
}


/*----------------------------------------------------------------*/
/* Read                                                           */
/*----------------------------------------------------------------*/

JNIEXPORT jint JNICALL Java_nativefile_NativeFile_ReadFile
  (JNIEnv * env, jclass cl, jlong jhandle, jbyteArray jbuffer, jint size)
{
	HANDLE hand;
	unsigned long ergebnis=0;
	unsigned long erg=0;
//    char *buffer;
    char buffer[1050];

	hand = (HANDLE)jhandle;

//	buffer = (*env)->GetByteArrayElements(env,jbuffer,0); // letzter parameter eigentlich pointer auf boolean ob copy

	if(size > 1024)
		size = 1024;

	
	if (ReadFile(hand, buffer, size, &ergebnis, 0))
		erg = ergebnis;
	else
		erg = -1;


	if(erg >= 0)
	{
			(*env)->SetByteArrayRegion(env, jbuffer, 0, ergebnis, (jbyte *) buffer );

//			(*env)->ReleaseByteArrayElements(env, jbuffer, buffer, 0 );

			return (int)ergebnis;
	}
	else
	{
			// ist wichtig hier, sonst frisst es Speicher auch wenn nix empfangen wird!
//		(*env)->ReleaseByteArrayElements(env, jbuffer, buffer, 0 );
		return -1;
	}
	return -2;  // wrong handle

}

/*----------------------------------------------------------------*/
/* Close                                                          */
/*----------------------------------------------------------------*/

JNIEXPORT void JNICALL Java_nativefile_NativeFile_CloseFile
  (JNIEnv * env, jclass cl, jlong jhandle)
{
	HANDLE hand;

	hand = (HANDLE)jhandle;

	FlushFileBuffers(hand);
	CloseHandle(hand);
}

/*----------------------------------------------------------------*/
/* Truncate Fiel (not for windows)                                */
/*----------------------------------------------------------------*/
JNIEXPORT void JNICALL Java_nativefile_NativeFile_TruncateFile
  (JNIEnv * env, jclass cl, jstring jfilename, jint size)
{
}


JNIEXPORT jint JNICALL Java_nativefile_NativeFile_GetLastError
  (JNIEnv * env, jclass cl)
{
	return GetLastError();
}


JNIEXPORT void JNICALL Java_nativefile_NativeFile_SetLastError
  (JNIEnv * env, jclass cl, jint jerror)
{
	SetLastError((DWORD)jerror);
}

/*----------------------------------------------------------------*/
/* Fragt ob Windows Ports zu benutzen sind                        */
/*----------------------------------------------------------------*/
JNIEXPORT jboolean JNICALL Java_nativefile_NativeFile_isWindows
  (JNIEnv * env , jclass cl)
{
	return 1;
}
